# ticos-sdk-for-miniprogram

## 安装

npm i ticos-sdk-for-miniprogram

## 使用方式

```typescript

// 初始化
import { iotEventType, TicosIotSdk, IDevice } from 'ticos-sdk-for-miniprogram';

const sdk = new TicosIotSdk({
  getToken,
});

sdk.init();

// 获取绑定设备列表
const { deviceList } = await sdk.cloudApi.getDeviceList();

// 绑定设备
await sdk.cloudApi.bindDevice({ productId: 'pro001', deviceId: 'device001' })
// 解绑设备
await ticosSdk.cloudApi.unbindDevice({ productId: 'pro001', deviceId: 'device001' })

// 监听设备, 通过设备ID监听
sdk.subscribe(['device001', 'device002']);
sdk.onMessage(iotEventType.TICOS_IOT_EVENT_PROPERTY, (message) => {
    console.log('*********device property change', message);
  })
sdk.onStatus((message) => {
    console.log('*********device status change ', message);
  })

其他功能或接口使用请参考 https://docs.ticos.cn/