"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TicosIotSdk = exports.iotEventType = void 0;
const tslib_1 = require("tslib");
const core_1 = require("./core");
const storage_1 = require("./libs/apiProvider/tisvc/untils/storage");
const constants = (0, tslib_1.__importStar)(require("./libs/apiProvider/tisvc/constants"));
const constants_1 = require("./libs/apiProvider/tisvc/constants");
var constants_2 = require("./libs/apiProvider/tisvc/constants");
Object.defineProperty(exports, "iotEventType", { enumerable: true, get: function () { return constants_2.iotEventType; } });
class TicosIotSdk {
    constructor({ getToken, }) {
        this.cloudApi = new core_1.CloudApi();
        this.getToken = getToken;
    }
    init() {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            yield this.authorizer();
            this.mqtt = new core_1.TisvcMqtt();
        });
    }
    authorizer() {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            const { access_token } = yield this.getToken();
            if (access_token) {
                yield (0, storage_1.setItem)(constants.cacheKeys.TICOS_API_TOKEN, access_token);
            }
        });
    }
    subscribe(deviceIdList) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            if (!this.mqtt) {
                console.log('********error', '未初始化实例');
                throw new Error('未初始化实例');
            }
            this.mqtt.subscribe(deviceIdList);
        });
    }
    isLogin() {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            const token = (0, storage_1.getItem)(constants.cacheKeys.TICOS_API_TOKEN);
            if (token)
                return true;
        });
    }
    onMessage(eventType, callback) {
        var _a;
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            (_a = this.mqtt) === null || _a === void 0 ? void 0 : _a.on(eventType, callback);
        });
    }
    onStatus(callback) {
        var _a;
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            (_a = this.mqtt) === null || _a === void 0 ? void 0 : _a.on(constants_1.iotEventType.TICOS_IOT_STATUS_CHANGE, callback);
        });
    }
}
exports.TicosIotSdk = TicosIotSdk;
//# sourceMappingURL=TicosIotSdk.js.map