"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudApi = void 0;
const tslib_1 = require("tslib");
// import { Action} from '../../libs/apiProvider/tencent'
const tisvc_1 = require("../../libs/apiProvider/tisvc");
class CloudApi {
    constructor() {
        this.getDeviceData = ({ deviceId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield this.tisvc.getDeviceData({ DeviceId: deviceId });
        });
        this.getProduct = ({ productId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield this.tisvc.getProduct({ ProductId: productId });
        });
        this.changeDeviceName = ({ productId, deviceId, aliasName, }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return this.tisvc.changeDeviceName({
                productId,
                deviceId,
                aliasName,
            });
        });
        this.bindDevice = ({ productId, deviceId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return this.tisvc.bindDevice({ productId, deviceId });
        });
        this.unbindDevice = ({ productId, deviceId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return this.tisvc.unbindDevice({ productId, deviceId });
        });
        // this.actions = new Action(apiProvider)
        this.tisvc = new tisvc_1.Action();
    }
    getDeviceList() {
        return this.tisvc.getDeviceList();
    }
    controlDeviceData(device, data) {
        return this.tisvc.controlDeviceData(device, data);
    }
}
exports.CloudApi = CloudApi;
//# sourceMappingURL=index.js.map