"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reducer = void 0;
const tslib_1 = require("tslib");
const actionTypes = (0, tslib_1.__importStar)(require("./actiontypes"));
const reducer = (state, action) => {
    const { type, payload } = action;
    switch (type) {
        case actionTypes.UPDATE_DEVICE_STATUS:
            return Object.assign(Object.assign({}, state), { deviceStatusMap: Object.assign(Object.assign({}, state.deviceStatusMap), payload.deviceStatusMap) });
        case actionTypes.UPDATE_PRODUCT_INFO_MAP:
            return Object.assign(Object.assign({}, state), { productInfoMap: Object.assign(Object.assign({}, state.productInfoMap), payload.productInfoMap) });
        case actionTypes.UPDATE_DEVICE_DATA_MAP:
            return Object.assign(Object.assign({}, state), { deviceDataMap: Object.assign(Object.assign({}, state.deviceDataMap), payload.deviceDataMap) });
        case actionTypes.UPDATE_DEVICE_STATUS_BY_PUSH:
            return Object.assign(Object.assign({}, state), { deviceStatusMap: Object.assign(Object.assign({}, state.deviceStatusMap), { [payload.deviceId]: payload.deviceStatus }) });
        case actionTypes.UPDATE_DEVICE_DATA_BY_PUSH: {
            return Object.assign(Object.assign({}, state), { deviceDataMap: Object.assign(Object.assign({}, state.deviceDataMap), { [payload.deviceId]: Object.assign(Object.assign({}, state.deviceDataMap[payload.deviceId]), payload.deviceData) }) });
        }
        case actionTypes.UPDATE_DEVICE_LIST:
            return Object.assign(Object.assign({}, state), { deviceList: payload.deviceList });
        case actionTypes.UPDATE_SHARE_DEVICE_LIST:
            return Object.assign(Object.assign({}, state), { shareDeviceList: payload.shareDeviceList.map((item) => (Object.assign(Object.assign({}, item), { isShareDevice: true }))) });
        case actionTypes.CLEAR_DEVICE_AND_PRODUCT_DATA:
            return Object.assign(Object.assign({}, state), { deviceDataMap: {}, deviceStatusMap: {}, productInfoMap: {}, deviceList: [], shareDeviceList: [] });
        case actionTypes.CONTROL_DEVICE_DATA: {
            const { deviceId, deviceData } = payload;
            const prevDeviceData = state.deviceDataMap[deviceId] || {};
            return Object.assign(Object.assign({}, state), { deviceDataMap: Object.assign(Object.assign({}, state.deviceDataMap), { [deviceId]: Object.assign(Object.assign({}, prevDeviceData), deviceData) }) });
        }
        case actionTypes.UPDATE_WIFI_LIST: {
            return Object.assign(Object.assign({}, state), { wifiList: payload.wifiList });
        }
        case actionTypes.RESET_WIFI_LIST: {
            return Object.assign(Object.assign({}, state), { wifiList: [] });
        }
        default:
            return Object.assign(Object.assign({}, state), payload);
    }
};
exports.reducer = reducer;
//# sourceMappingURL=reducer.js.map