"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = void 0;
const tslib_1 = require("tslib");
const devices_1 = require("./devices");
const products_1 = require("./products");
class Action {
    constructor() {
        this.controlDeviceData = (device, data) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            yield this.devices.controlDeviceData(device, data);
        });
        this.getDeviceList = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            const list = yield this.devices.getDeviceList();
            return list;
        });
        this.getDeviceData = ({ DeviceId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            const data = yield this.devices.getDeviceData({ DeviceId });
            return data;
        });
        this.getProduct = ({ ProductId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield this.products.getProduct({ ProductId });
        });
        this.bindDevice = ({ productId, deviceId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield this.devices.bindDevice({ productId, deviceId });
        });
        this.unbindDevice = ({ productId, deviceId }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield this.devices.unbindDevice({ productId, deviceId });
        });
        this.changeDeviceName = ({ productId, deviceId, aliasName }) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return yield this.devices.changeDeviceName({ productId, deviceId, aliasName });
        });
        this.devices = new devices_1.Devices();
        this.products = new products_1.Products();
    }
}
exports.Action = Action;
//# sourceMappingURL=actions.js.map