"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getENV = exports.isBrowser = exports.isMiniProgram = void 0;
const isMiniProgram = () => { return (0, exports.getENV)() === 'isMiniProgram'; };
exports.isMiniProgram = isMiniProgram;
const isBrowser = () => { return (0, exports.getENV)() === 'isBrowser'; };
exports.isBrowser = isBrowser;
const getENV = () => {
    try {
        const ua = navigator.userAgent.toLowerCase();
        const isMiniProgram = ua.indexOf('micromessenger') !== -1;
        const isInApp = /(^|;\s)app\//.test(ua);
        const isWebview = ua.indexOf('webview') !== -1;
        if (isWebview) {
            return 'isBrowser';
        }
        if (isMiniProgram) {
            return 'isMiniProgram';
        }
        else {
            return isInApp ? 'app' : 'isBrowser';
        }
    }
    catch (error) {
        return 'isMiniProgram';
    }
};
exports.getENV = getENV;
//# sourceMappingURL=env.js.map