"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.request = exports.requestWeapp = exports.requestXHR = void 0;
const tslib_2 = require("tslib");
const env_detect_1 = (0, tslib_2.__importStar)(require("../env"));
// let maxConcurrentNum=10,currentRequestingNum=0,jsonpcallbackCounter=0;
// export const requestXHR = (e,t,r) => {
//   // return new Promise()
//   return { data: {}}
// }
const requestXHR = (url, data, options) => new Promise((resolve, reject) => {
    fetch(url, Object.assign(Object.assign({ credentials: 'include', body: JSON.stringify(data) }, options), { headers: Object.assign({ 'Content-Type': 'application/json' }, options.headers) }))
        .then((response) => {
        switch (response.status) {
            case 200:
            case 201:
            case 202:
                return response.json();
            case 204:
                if (options.method === 'DELETE') {
                    return {
                        success: true,
                    };
                }
                return {
                    successful: false,
                    code: response.status,
                };
            case 400:
            case 401:
            case 403:
            case 404:
            case 406:
            case 410:
            case 422:
            case 500:
                return response
                    .json()
                    .then((res) => ({
                    successful: false,
                    code: response.status,
                    data: res,
                }))
                    .catch(() => ({
                    successful: false,
                    code: response.status,
                }));
            default:
                return null;
        }
    })
        .then((json) => {
        if (json && json.successful !== false) {
            resolve(json);
        }
        else {
            const j = Object.assign({}, json);
            delete j.successful;
            reject(j);
        }
    })
        .catch((err) => {
        reject(err);
    });
});
exports.requestXHR = requestXHR;
const requestWeapp = (e) => (0, tslib_2.__awaiter)(void 0, void 0, void 0, function* () {
    // const 
    // const requestTask = wx.request({
    //   url: path, //仅为示例，并非真实的接口地址
    //   data,
    //   method,
    //   header: {
    //     'content-type': 'application/json',
    //     ...options
    //   },
    //   success (res) {
    //     console.log(res.data)
    //   }
    // })
    // if(currentRequestingNum>=maxConcurrentNum) request_manager_1.startBlocking()
    const p = new Promise((resolve, reject) => {
        wx.request(Object.assign(Object.assign({}, e), { success: res => {
                resolve(res.data);
            }, fail: err => {
                reject(err);
            } }));
    });
    return yield p;
    // return tslib_1.__awaiter(this,void 0,(() => void 0),(() => {
    //   var t,r,s;return tslib_1.__generator(this,(function(n){switch(n.label){
    //      case 0:n.trys.push([0,7,8,9]),n.label=1;
    // case 1:return currentRequestingNum>=maxConcurrentNum?[4,request_manager_1.startBlocking()]:[3,3];
    //     case 2:return n.sent(),[3,1];
    //     case 3:return currentRequestingNum++,"jsonp"!==e.dataType?[3,5]:(e.method="GET",
    //       t=e.callback||"jsonpcallback"+ ++jsonpcallbackCounter,
    //       e.url=utillib_1.appendParams(e.url,{callback:t}),[4,pify(wx.request)(e)]);
    //     case 4:return 200===(r=n.sent()).statusCode&&r.data&&"string"==typeof r.data&&
    //     (r.data=utillib_1.jsonp2json(r.data)),[2,r];
    //     case 5:return[4,pify(wx.request)(e)];
    //     case 6:return[2,n.sent()];
    //     case 7:return s=n.sent(),[2,Promise.reject(s)];
    // case 8:return currentRequestingNum--,request_manager_1.resolveFirstBlock(),[7];
    //     case 9:return[2]}}))}))
});
exports.requestWeapp = requestWeapp;
const request = (e) => (0, tslib_2.__awaiter)(void 0, void 0, void 0, function* () {
    const { url, data, header, method, dataType, responseType } = e, params = (0, tslib_2.__rest)(e, ["url", "data", "header", "method", "dataType", "responseType"]);
    return env_detect_1.isBrowser() ? (0, exports.requestXHR)(url, data, { headers: header, method, responseType, dataType }) : (0, exports.requestWeapp)({ url, data, header, method,
        dataType, responseType });
    // return tslib_1.__awaiter(void 0,void 0,(() => void 0),(
    //   () => {var t=url,r=data,s=header,n=void 0===s?{}:s,
    //   a=method,u=void 0===a?"GET":a,i=dataType,o=responseType,
    //   c=tslib_1.__rest(e,["url","data","header","method","dataType","responseType"]);
    //     return tslib_1.__generator(this,((e) => {
    //       return env_detect_1.isBrowser()?
    //       [2,requestXHR(t,r,{headers:n,method:u,responseType:o,dataType:i})]:
    //       [2,requestWeapp(tslib_1.__assign({url:t,data:r,header:n,method:u,
    //         dataType:i,responseType:o},c))]}))}))
});
exports.request = request;
//# sourceMappingURL=request.js.map