"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hexToArrayBuffer = exports.arrayBufferToHexStringArray = exports.hexToStr = exports.isObject = exports.isEmpty = exports.isArray = exports.getType = exports.hasModalShow = exports.isPlainObject = exports.getErrorMsg = exports.noop = exports.delay = exports.appendParams = exports.fetchAllList = exports.jsonp2json = exports.cutoffLong = exports.genPromise = void 0;
const tslib_2 = require("tslib");
const tslib_1 = (0, tslib_2.__importStar)(require("tslib"));
// import * as constants_1 from '../constants'
const logger_1 = (0, tslib_2.__importStar)(require("./logger"));
const matchTypeReg = /^\[object\s(\w+)\]$/;
const genPromise = () => { var r, t; return { promise: new Promise(((e, o) => { r = e, t = o; })), resolve: r, reject: t }; };
exports.genPromise = genPromise;
const cutoffLong = (r, t, e, o) => { void 0 === t && (t = 4096), void 0 === e && (e = 10), void 0 === o && (o = 20); try {
    const n = (r, t, e) => { return r ? "string" == typeof r && r.length > t ? r.substr(0, t) + "... (" + (r.length - t) + " characters truncated)" : Array.isArray(r) ? r.length > e ? r.slice(0, e).map(((r) => { return n(r, t, e); })).concat("... (" + (r.length - e) + " items truncated)") : r : "object" == typeof r ? Object.keys(r).reduce(((s, i, a, c) => { return a < o ? s[i] = n(r[i], t, e) : a === o && (s[c.length - o + " keys truncated"] = 1), s; }), {}) : r : r; };
    return n(r, t, e);
}
catch (t) {
    return logger_1.logger.debug("cutoffLong fail", t), r;
} };
exports.cutoffLong = cutoffLong;
const jsonp2json = (r) => { var t = r.indexOf("("), e = {}; if (t > -1)
    try {
        "'" === (r = r.substring(t + 1, r.length - 1))[0] && "'" === r[r.length - 1] && (r = r.substring(1, r.length - 1)), e = JSON.parse(r);
    }
    catch (r) {
        console.error(r);
    } return e; };
exports.jsonp2json = jsonp2json;
const fetchAllList = (r) => { return tslib_1.__awaiter(this, void 0, (() => void 0), (() => { var t, e, o, n, s; return tslib_1.__generator(this, (function (i) { switch (i.label) {
    case 0: t = 100, e = 0, o = 100, n = [], i.label = 1;
    case 1: return 0 === e || n.length < o ? [4, r({ offset: e, limit: t })] : [3, 3];
    case 2: return (s = i.sent()).list.length ? (o = s.total, e += t, n = n.concat(s.list), [3, 1]) : [2, n];
    case 3: return [2, n];
} })); })); };
exports.fetchAllList = fetchAllList;
const appendParams = (r, t) => { void 0 === t && (t = {}); var e = []; return Object.keys(t).forEach(((r) => { var o = t[r]; if (void 0 !== o) {
    if (exports.isPlainObject(o))
        try {
            o = JSON.stringify(o);
        }
        catch (r) { }
    e.push(r + "=" + encodeURIComponent(o));
} })), e.length ? (r.indexOf("?") > -1 ? r + "&" : r + "?") + e.join("&") : r; };
exports.appendParams = appendParams;
const delay = (r) => { return new Promise((function (t) { return setTimeout(t, r); })); };
exports.delay = delay;
const noop = () => { };
exports.noop = noop;
const getErrorMsg = (r) => { if (r) {
    var t = "";
    return "string" == typeof r ? r : (t = r.msg || r.Message || r.message || r.errMsg || "连接服务器失败，请稍后再试", r.reqId && (t += "(" + r.reqId + ")"), t || (t = "连接服务器失败，请稍后再试"), t);
} };
exports.getErrorMsg = getErrorMsg;
const isPlainObject = (r) => { if ("object" != (void 0 === r ? "undefined" : typeof r) || null === r)
    return !1; for (var t = r; null !== Object.getPrototypeOf(t);)
    t = Object.getPrototypeOf(t); return Object.getPrototypeOf(r) === t; };
exports.isPlainObject = isPlainObject;
exports.hasModalShow = !1;
// export const showModal=function(r,t,e){
//   void 0===t&&(t="");var o=e.confirmText,n=void 0===o?"确定":o,s=e.confirmColor,i=void 0===s?constants_1.themeColorMap.primary:s,a=e.cancelText,c=void 0===a?"取消":a,f=e.cancelColor,u=void 0===f?constants_1.themeColorMap.weak:f,l=tslib_1.__rest(e,["confirmText","confirmColor","cancelText","cancelColor"]);return wx.hideToast();
//     export const hasModalShow=!0,new Promise((function(e){wx.showModal(tslib_1.__assign(tslib_1.__assign({title:r,content:t,confirmText:n,confirmColor:i,cancelColor:u,cancelText:c},l),{success:function(r){var t=r.confirm;e(!!t)},fail:function(){e(!1)},complete:function(){exports.hasModalShow=!1}}))}
// ))};
const getType = (r) => { var t = Object.prototype.toString.call(r).toLowerCase().match(matchTypeReg); return t ? t[1] : "unknown"; };
exports.getType = getType;
const isArray = (r) => { return "array" === (0, exports.getType)(r); };
exports.isArray = isArray;
const isEmpty = (r) => { if (!r)
    return !0; if (Array.isArray(r))
    return 0 === r.length; for (var t in r)
    return !1; return !0; };
exports.isEmpty = isEmpty;
const isObject = (r) => { var t = typeof r; return ("function" === t || "object" === t) && !!r; };
exports.isObject = isObject;
const hexToStr = (r) => { var t, e = String(r).trim(), o = "0x" === e.substr(0, 2).toLowerCase() ? e.substr(2) : e, n = o.length; if (n % 2 != 0)
    throw "Illegal Format ASCII Code"; for (var s = [], i = 0; i < n; i += 2)
    t = parseInt(o.substr(i, 2), 16), s.push(String.fromCharCode(t)); return s.join(""); };
exports.hexToStr = hexToStr;
const arrayBufferToHexStringArray = (r) => { try {
    if (Array.isArray(r) && r.every((function (r) { return "string" == typeof r; })))
        return r;
    if ("string" == typeof r) {
        var t = [""];
        return r.split("").forEach((function (r, e) { t[t.length - 1] += r, e % 2 && t.push(""); })), t.splice(t.length - 1, 1), t;
    }
    if ("[object ArrayBuffer]" !== Object.prototype.toString.call(r))
        throw "invalid array buffer";
    for (var e = new DataView(r), o = [], n = 0, s = e.byteLength; n < s; n++) {
        var i = (255 & e.getUint8(n)).toString(16);
        i = 1 === i.length ? "0" + i : i, o.push(i.toUpperCase());
    }
    return o;
}
catch (r) {
    return console.error("arrayBufferToHexStringArray error", r), [];
} };
exports.arrayBufferToHexStringArray = arrayBufferToHexStringArray;
const hexToArrayBuffer = (r) => { return new Uint8Array(r.match(/[\da-f]{2}/gi).map((function (r) { return parseInt(r, 16); }))).buffer; };
exports.hexToArrayBuffer = hexToArrayBuffer;
// export const tryCallHandler =(r,t) => {for(var e=[],o=2;o<arguments.length;o++)e[o-2]=arguments[o];"function"==typeof r["_"+t+"Handler"]&&r["_"+t+"Handler"].apply(r,tslib_1.__spread(e))}
//# sourceMappingURL=utillib.js.map
//# sourceMappingURL=utillib.js.map