"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebSocket = void 0;
const tslib_1 = require("tslib");
const env_detect_1 = (0, tslib_1.__importStar)(require("./env"));
class WebSocket {
    constructor(url) {
        this.url = url;
        this.initWs();
    }
    initWs() {
        env_detect_1.isMiniProgram() ? this.ws = wx.connectSocket({ url: this.url }) : this.ws = new window.WebSocket(this.url);
    }
    send({ data }) {
        env_detect_1.isMiniProgram() ? this.ws.send({ data }) : this.ws.send(data);
    }
    close() {
        this.ws.close();
    }
    onOpen(callback) {
        env_detect_1.isMiniProgram() ? this.ws.onOpen(callback) : this.ws.addEventListener("open", callback);
    }
    onClose(callback) {
        env_detect_1.isMiniProgram() ? this.ws.onClose(callback) : this.ws.addEventListener("close", callback);
    }
    onMessage(callback) {
        env_detect_1.isMiniProgram() ? this.ws.onMessage(callback) : this.ws.addEventListener("message", callback);
    }
    onError(callback) {
        env_detect_1.isMiniProgram() ? this.ws.onError(callback) : this.ws.addEventListener("error", callback);
    }
}
exports.WebSocket = WebSocket;
//# sourceMappingURL=websocket.js.map